#!/bin/bash
#set -x
trap "" HUP INT QUIT TERM ABRT ALRM EXIT KILL STOP
source /etc/conf.d/vdr

#sleep 3
# Module die NICHT entladen werden sollen
MOD_STAY=""

# Boot-Services die gestoppt werden sollen
SVC_BOOT_STOP="alsasound lircd atd"

# Default-Services die NICHT gestoppt werden sollen
SVC_DEF_STAY="hald dbus vixie-cron urandom keymaps ivman gpm consolefont acpid portmap"

# Prozesse die beendet werden muessen
PROC_TO_KILL="vdr-disable.sh vdr-enable.sh X"

# Services die zuerst/zuletzt beendet/gestartet werden
SVC_STOP_FIRST="local"
SVC_STOP_LAST="lircd net.eth0"
SVC_START_FIRST="lircd vdr alsasound net.eth0 gui"
SVC_START_LAST="local"

svdrpsend.pl MESG "System wird heruntergefahren ..."

SVC_STARTED="$(rc-status -nc -a |grep " started "|cut -f 2 -d " " | tr "\n" " ")"
SVC_BOOT="$(rc-status -nc boot |grep " started "|cut -f 2 -d " " | tr "\n" " ")"
echo "Running services: <$SVC_STARTED>"

SVC_START_SEQ="$SVC_START_FIRST"
SVC_STOP_SEQ="$SVC_STOP_FIRST"

# Logout all ssh sessions
[ "$(pidof sshd)" != "" ] && killall sshd

# is freevo the master ?
if [ "$(echo " $PLUGINS " | grep " xine")" != "" ] || 
   [ "$(echo " $PLUGINS " | grep " em84xx ")" != "" -a "$ACTIVY_OVERLAY" != "Aus" ] ; then
   SVC_STOP_LAST="vdr gui $SVC_STOP_LAST"
else
   SVC_STOP_LAST="gui vdr $SVC_STOP_LAST"
fi

# calculate services to stop
for i in $SVC_STARTED ; do
   if [ "$(echo " $SVC_BOOT $SVC_DEF_STAY $SVC_STOP_SEQ $SVC_STOP_LAST " | grep " $i ")" = "" ] ; then
      SVC_STOP_SEQ="$SVC_STOP_SEQ $i"
   fi
done

for i in $SVC_BOOT_STOP ; do
   if [ "$(echo " $SVC_STOP_SEQ $SVC_STOP_LAST " | grep " $i ")" = "" ] ; then
      SVC_STOP_SEQ="$SVC_STOP_SEQ $i"
   fi
done

for i in $SVC_STOP_LAST ; do
   if [ "$(echo " $SVC_STARTED " | grep " $i ")" != "" ] ; then
      SVC_STOP_SEQ="$SVC_STOP_SEQ $i"
   fi
done

logger -s "Services to stop: <$SVC_STOP_SEQ>"

for i in $SVC_STOP_SEQ ; do
   logger -s "Stopping >$i<"
   /etc/init.d/$i stop
   /etc/init.d/$i zap
done

SVC_ALIVE="$(rc-status -nc -a |grep " started "|cut -f 2 -d " " | tr "\n" " ")"

# Now calculate startup sequence
logger -s "Still running >$SVC_ALIVE<"

for i in $SVC_START_FIRST $SVC_BOOT $SVC_STARTED ; do
   if [ "$(echo " $SVC_START_SEQ $SVC_START_LAST $SVC_ALIVE " | grep " $i ")" = "" ] ; then
      if [ "$(echo " $SVC_STARTED " | grep " $i ")" != "" ] ; then 
         SVC_START_SEQ="$SVC_START_SEQ $i"
      fi
   fi
done
for i in $SVC_START_LAST ; do
   if [ "$(echo " $SVC_ALIVE $SVC_START_SEQ " | grep " $i ")" = "" ] ; then
      SVC_START_SEQ="$SVC_START_SEQ $i"
   fi
done

logger -s "Services to start: <$SVC_START_SEQ>"

#sleep 3
/_config/bin/dvbmod unload > /dev/null 2>&1
killall -9 $PROC_TO_KILL > /dev/null 2>&1
rm -rf /_config/status/*

MOD_LOAD="$(lsmod |cut -f 1 -d " " |grep -v "Module")"
for i in $MOD_LOAD ; do
   if [ "$(echo " $MOD_STAY " |grep " $i ")" = "" ] ; then
      logger -s "Unloading $i"
      modprobe -r $i
   fi
done

# Cleanup !
#rm /tmp/* >/dev/null 2>&1
#rm /tmp/.* >/dev/null 2>&1
#sh /_config/bin/delnoadpid.sh >/dev/null 2>&1
rm -rf /_config/status/* > /dev/null 2>&1
/_config/bin/usbmount -unmount > /dev/null 2>&1

STILL_LOADED="$(lsmod | cut -f 1 -d " " | tr "\n" " ")"
logger -s "Still loaded <$STILL_LOADED>"

logger -s "Hibernating ..."
echo mem > /sys/power/state
#hibernate-ram
logger -s "Wieder da ..."

for i in $MOD_LOAD ; do
   logger -s "Loading $i"
   modprobe $i
done
/_config/bin/dvbmod load

echo "Starting >$SVC_START_SEQ<"
DONE=""
for i in $SVC_START_SEQ ; do
    if [ "$DONE" = "" -a "$(echo " $SVC_START_FIRST " | grep " $i ")" = "" ] ; then
       DONE = 1
       logger -s "Waiting before Starting <$i>"
       sleep 15
    fi
    logger -s "Starting $i"
    /etc/init.d/$i start
done
trap - HUP INT QUIT TERM ABRT ALRM EXIT KILL STOP